<template>
  <h2>Formulaire généré</h2>
  <form>
    <div v-for="item in addressSchema" :key="item.field">
      <label>{{ item.label }}</label>
      <input
        v-bind="item.attrs"
        :value="this[item.field]"
        @input="$emit('update:' + item.field, $event.target.value)"
      />
    </div>
  </form>
  <h2>Formulaire avec v-model</h2>
  <form>
    <div v-for="item in addressSchema" :key="item.field">
      <label>{{ item.label }}</label>
      <input v-bind="item.attrs" v-model="localAddress[item.field]" />
    </div>
  </form>
  <button @click="$emit('update:address', localAddress)">Sauvegarder</button>
  <button @click="$emit('close')">X Fermer</button>
</template>

<script lang="js">
export default {
  props: {
    label: {
      type: String,
      default: 'Unknown'
    },
    address: Object,
    road: String,
    zipCode: String,
    complement: String,
    state: String,
    country: String,
    city: String,
  },
  emits: [
    'close',
    'update:address',
    'update:road',
    'update:zipCode',
    'update:complement',
    'update:state',
    'update:country',
    'update:city',
  ],
  data () {
    return {
      localAddress: {
        ...this.address,
      },
      addressSchema: [{
        attrs: { type: "text" },
        label: "Road",
        field: "road"
      }, {
        attrs: {
          type: "string", // est ce que le code postal est vraiment un number ?
          style: "color: red"
        },
        label: "Zip Code",
        field: "zipCode"
      }, {
        attrs: { type: "text" },
        label: "Complement",
        field: "complement"
      }, {
        attrs: { type: "text" },
        label: "State",
        field: "state"
      }, {
        attrs: { type: "text" },
        label: "Country",
        field: "country"
      }, {
        attrs: { type: "text" },
        label: "City",
        field: "city"
      }],
    }
  }
}
</script>
